/*
	Write by LinJiangHua(xempo) 2012-2015
	Free under LGPL
*/

#ifndef  TEXT_STYLE
#define  TEXT_STYLE

#define colorVal( a, b, c)  ( (c) | ((b)<<8) | ((a)<<16) )

typedef struct {
const char *fast,
*bflm,     /* before limited */
*aflm;	   /* after limited  */
const int fastlen,
bflen,     /* bflm len */
aflen,    /* aflm len */
cnt;
}TxtStyle;

#define  c_style_count	24
#define  cs_modul_cnt  2

typedef struct {
const unsigned int color;
const  char bold, italic, underline;
}StyleVal;

extern TxtStyle freeStyles[c_style_count+1];
extern const char **_CType[c_style_count+1];
extern const StyleVal *_colors[cs_modul_cnt];
extern const unsigned int lineStyle[2][3];

#define  log_style_count  2
extern const TxtStyle logStyles[];
extern const char **logKeys[];
extern const StyleVal logColor[];
extern const unsigned int logLineStyle[3];

#define  rls_style_count  3
extern const TxtStyle rlsStyles[];
extern const char **rlsKeys[];
extern const StyleVal rlsColor[];
extern const unsigned int rlsLineStyle[3];

#endif
