/*
	Write by xempo 9 2014
	Free under LGPL
*/

#ifndef  Grap_Simple_Edit
#define  Grap_Simple_Edit

#include <qmainwindow.h>
#include <qaction.h>
#include <qlabel.h>
#include "statuspanel.h"

class Filesan;

class SimpleImage : public QMainWindow
{
 moc_Object
public:
   SimpleImage(QWidget* parent);
//   ~SimpleImage();
void exe(const char *f);
void showTop();
QImage *getImage() const
{ return img; }

protected :
bool event(QEvent *e);

private :
QImage *img;
int P, _isMax;
QToolBar *tb;
StatusPanel *sbar;
QLabel *lab;
Filesan *fs;

QAction *mdfAct, *saveAct, *helpAct,
	*moreSizeAct, *lessSizeAct, *normalSizeAct;
ActMenu *editMenu;
const char *fn;
int pasteId, copyId, flip1Id, flip2Id, flip3Id, scaleId, depthId[3],
	tms, tmId;
void status();
void countWH(int &w, int &h);
void imageMirror( bool h, bool v);
void imageCopy();
void imagePaste();
};

extern QPtrList <SimpleImage> grapList;
#endif
