/*
	Write & edit by Linjianghua(xempo)
	Copyright 2005 Linjianghua(xempo)
	Reserve all rights of this file
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef  _LINUX_SOURCE
#define  DIV_CH  '/'
#else
#define DIV_CH  '\\'
#endif

char *catstr(const char *pth,const char *fnam, char chr)
{
unsigned int len=pth? strlen(pth):0;
char *chs=(char *)malloc(len+strlen(fnam)+5);
if(pth)strcpy(chs,pth);
if(chr && (len==0 || chs[len-1]!=chr) )chs[len++]=chr;
strcpy(chs+len, fnam);
return chs;
}


#ifdef  __Fast
#define isSpace(ch) (ch==32)
#define notSpace(ch) (ch!=32)
unsigned  FmtText(char *buf,unsigned  len)
{
  register unsigned  i;
  for(i=0;i<len;i++)switch(buf[i]){
	case '\r' : if(buf[i+1]=='\n'){
		  register  unsigned j;
		  for(j=i; j<len; j++)buf[j]=buf[j+1];
		  len--;
		}
		else buf[i]='\n';
		break;
	case 9 : buf[i]=32;
	}
  return len;
}
#else
#define isSpace(ch) (ch==32||ch==9)
#define notSpace(ch) (ch!=32&&ch!=9)
unsigned  FmtText(char *buf,unsigned  len)
{
  register unsigned  i;
  for(i=0; i<len; i++)if(buf[i]=='\r'){
	if(buf[i+1]=='\n'){
		  register  unsigned j;
		  for(j=i; j<len; j++)buf[j]=buf[j+1];
		  len--;
	}
	else buf[i]='\n';
  }
  return len;
}
#endif

char *_ProgPath;
FILE *PathOpen(const char *fn,const char *fmode)
{
FILE *fp;
const char *pt=fn;
start: fp=fopen(pt,fmode);
if(fp==NULL){
	if(pt==fn&&_ProgPath){
		pt=catstr(_ProgPath,fn, DIV_CH);
		goto start;
		}
	}
if(pt!=fn)free((void *)pt);
return fp;
}


char *ReadFile(const char *fname,unsigned int *filelen)
{
unsigned int len;
char *buf;
FILE *fp=PathOpen(fname,"rb");
if(fp==NULL){ perror(fname); return NULL; }
else { /* open ok */
  fseek(fp,0,2);  len=ftell(fp);
  buf=(char *)malloc(len+4);
  if(buf==NULL){
	puts("Fail to alloc memory !");
	fclose(fp);	return NULL;
	}
  rewind(fp);
  len=fread(buf,1,len,fp);
  fclose(fp);	buf[len]=0;
  *filelen=FmtText(buf,len);
  return buf;
	}
}

