/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2011
  Free under LGPL
*/

#include "ordir.h"
#include "dirloop.h"
#include "infor.h"
#include "ortime.h"
#include "stdfun.h"
#include "options.h"

static int ch_mode;
static BYTE DataBuf[OrlTmLen];

void (*pChMT)(__ORD *dir, int msg);

#define	ORL_ModeLen		1

int nChMT(__ORD *dir,BYTE *fct)
{
if((dir->mode&ORL_OEM)==0){
  int i, chmsg=0, Num_FCUs_Block=dir->Num_FCUs_Block,
	unitlen=dir->Num_FCU_Len;/* protect bit flow */
  BYTE *fcu=fct;
  for(i=0;i<Num_FCUs_Block;i++,fcu+=unitlen)
   if((*fcu&3)==1 && (fcu[1]&ORL_OEM)==0 ){
	if(ch_mode!=OrlTmLen)memcpy(fcu+1, DataBuf, ORL_ModeLen);
	else if(fcu[1]&ORL_MW)memcpy(fcu+FCU_TimePos, DataBuf, OrlTmLen);
	chmsg=1;
	}
  if(chmsg)dkwrite(dir->lib,dir->pos_numb_FCT, fct, Num_FCUs_Block*unitlen);
}
return 1;
}

int dChMT(__ORD *pcdir,__ORD *dir)
{
 if((dir->mode&ORL_OEM)==0){
	if(ch_mode!=OrlTmLen){
		dkwrite(dir->lib,dir->Own_FCU_Addr+1,DataBuf,ORL_ModeLen);
		dir->mode=*DataBuf;
		}
	else if(dir->mode&ORL_MW){
		dkwrite(dir->lib,dir->Own_FCU_Addr+FCU_TimePos, DataBuf, OrlTmLen);
		memcpy(dir->datebuf,DataBuf, OrlTmLen);
		}
	}
 return 1;
/* else return 2;  can't brow its beint */
}

void chMT(__ORD *dir0, int n, char **pm, int nCom)
{
#define Is_Mode() nCom!=ORL_chdate
  __ORD *dir;
  int i, msg, numb;
  BOOL isNum;
  __ORL *lib=dir0->lib;
  /* -------- Get DataBuf begin (Init part)---------- */

 arglists *lst;
 int brwVal[BrowsModeCnt];

#define  mu2  1
 int rt=0;// memset(mu2val, 0, sizeof(int)*mu2);
 static const char *mu2mo="-M",*_mu2mo="--mode",
	*mu2ti="-T",*_mu2ti="--time";
 memset(brwVal, 0, sizeof(int)*BrowsModeCnt);
 ProcOpt optBrows={	BrowsModeCnt,	browsMode, _browsMode,	brwVal,	0, NULL, 0	},
  opt2={	mu2,
	nCom==ORL_chmode ? &mu2mo : &mu2ti,
	nCom==ORL_chmode ? &_mu2mo : &_mu2ti,
	&rt, 0, NULL, 0
	};
  lst=procParas(n, pm, &optBrows, &opt2);
  if(lst->argc==0){
	ORtips(60, True);
	goto _usage_;
	}
  rt&=0x7fff;
  switch(nCom){
  case ORL_chmode : 
	if( rt ){
	      msg=cvtPara(lst->subarg->argv[0],"rwho-");
	      if(msg<0){
		ORtips(44,True);
_usage_:	showUsage(nCom);
		goto _ex_;
	      }
	      if(msg&ORL_OEM){ /* can't chmode it to OEM, only creat ... */
		ORtips(42,True); goto _ex_;
		}
	      *DataBuf=msg;
    	}
	break;
  case ORL_chdate :
	if(rt==0){
		ORtips(51, True);
		showUsage(nCom);
		goto _ex_;
	}
	struct tm dt;
	smtime(lst->subarg->argv[0], &dt);
	ORtime(mktime(&dt),DataBuf);
  }
/*------ get DataBuf end --------*/
msg=getBM(brwVal);
for(i=0; i<lst->argc; i++){
  isNum=adjNumb((char *)lst->argv[i]);
  dir=ORDopen(dir0, isNum ? divPath((char *)lst->argv[i],&numb) : lst->argv[i], DIR_BROW );
  if(idxdscpt<0x7ffd){ reportBug(); continue; }
  if(isNum){
    BYTE *stat;
    switch(nCom){
    case ORL_chmode :
	if((stat=seekFCU(dir,numb,NULL,NUMB_BROW))!=NULL){
	  if(rt==0)showFCU(dir, stat, True);
	  else {
		if((dir->mode&ORL_OEM)==0||(stat[1]&ORL_OEM)==0)dkwrite(lib,lib->FCU_dyw+1,DataBuf,1);
		else ORtips(45,True);
	  }
	  free(stat);
	}
	else reportBug();
	break;
    case ORL_chdate :
	if((stat=seekFCU(dir,numb,NULL,NUMB_REN/* togg mode-member */))!=NULL){
	   dkwrite(lib,lib->FCU_dyw+FCU_TimePos, DataBuf, OrlTmLen);
	   free(stat);
	}
	else reportBug();
//	break;
    }/* sw */
  }
  else {
      if(rt==0)showORD(dir, dir->name);
      else switch(nCom){
	case ORL_chdate : 
		if(dir->mode&ORL_MW){
			ch_mode=OrlTmLen; /* len, dkwrite(...) */
			goto _skp1_;
			}
		else ORtips(15, True);
		break;
	case ORL_chmode : ch_mode=ORL_ModeLen; /* data len */
	_skp1_:	if((msg&LoopDirSub))msg|=LoopNum;
	     ORDbrowth(dir,msg,nChMT,dChMT);
	     if((dir->mode&ORL_OEM)==0){/* chself */
		    dkwrite(lib,dir->Own_FCU_Addr+(Is_Mode()? 1:2),DataBuf,ch_mode);
		    if(Is_Mode())dir->mode=*DataBuf;
		    else memcpy(dir->datebuf,DataBuf, OrlTmLen);
	     }
	     else ORtips(45,True);
//		break;
	}/* sw */
  }
 if(pChMT)pChMT(dir, msg);
 ORDclose(dir,1);
}
_ex_ : argsFree(lst);
}

