/*
	Write by xempo 2014
	Free under LGPL
*/
#include <qaccel.h>
#include "cfgwidget.h"
#include "../rtdata/en/target/cfg.h"

const char fastKey[]="fast(int)", sure[]="sure()";

CfgWidget::CfgWidget(QWidget *par, const char *nam) :
	QWidget(par, nam, WDestructiveClose|WType_TopLevel),
	fntSz(fontHeight)
{
setFont(par->font());
}

void CfgWidget::showTop()
{
if(isMinimized()){
	showNormal();
	appPost(65201, this, parentWidget());
	}
else {
	raise(); setActiveWindow();
	}
}

void CfgWidget::execu(const int w1, const int h1, const int id)
{
int w, h;
static const char *slot[2]={ SLOT(sure()), SLOT(close()) };
_cfg_=charsFromORL(id);
w=w1*fontHeight;
h=h1*fontHeight;
setFixedSize( w, h );
tabwdg=new QTabWidget(this);
tabh=h-(2+3)*fntSz; tabw=w-2*fntSz;
tabwdg->setGeometry( fntSz, fntSz, tabw,  tabh );

QPushButton *Btn[2];
createBtns(this, Btn, _cfg_, 2, w, h-3*fntSz, slot, NULL);
sureBtn=Btn[0];
cancelBtn=Btn[1];
setCaption(QString::fromUtf8( _cfg_[2] ));
static const int keys[2]={ Key_F10, Key_F12 };
QAccel  *Acc=new QAccel(this);
for(w=0; w<2; w++)
	Acc->insertItem(QKeySequence(keys[w]), 600+w);
connect(Acc, sigactIdx, this, SLOT(fast(int)) );
}

CfgWidget::~CfgWidget()
{
free((void *)_cfg_[0]);
free((void *)_cfg_);
}
