/*
	林江华编写，保留版权，2010年10月
	develop 2012
*/
#ifndef		LIB_X_NORM
#define		LIB_X_NORM

#include <qapplication.h>
#include <qpopupmenu.h>
#include <qimage.h>
#include <qlistview.h>
#include <qaction.h>
#include <qpushbutton.h>
#include <qmetaobject.h>
#include "listcontent.h"
#include "helpwdg.h"
#include "fastblock.h"
#include "listopera.h"
#include "orkern.h"

class StatusPanel;

extern const char slot_up[], slot_down[];

enum sysfile {
	passwdFile=1,	groupFile=2
};

#define  ICO_SEPA  7
#define  DIR_OFF  14

/* Opera List's Object */
#define  OLO  (0x423fb3<<8)

enum FattribIcon { ICO_NORM=0, ICO_LINKOBJ=1, ICO_NOREAD=2,
	ICO_EXEC_FILE=3, ICO_LINKNONE=4, ICO_ARCH=5, ICO_ORL_AR=6,

	ICO_NOEXEC=17,  ICO_NOWRITE=18, ICO_HOMEDIR=19,	imgWait=20,
	ICO_SEARCH=28,
	ICO_ORL_WRI=32,

/*	ICO_ISDIR=1024, */
	ICO_LOSTTAGS=2048   };


#define   colOptCnt  7
#define   SpeCodecCnt  5

extern QTextCodec *strCodec;

extern int currentCodec;

extern QAction *creatTA(QWidget *w, QToolBar *tb, int img, const char *txt, const char *slot, int key);

enum spe_code { sp_uni=1, sp_utf8=2, sp_ms_uni=3, sp_lat=4 };
extern QTextCodec * _setCodec(int code);
extern void setMenuChk(QPopupMenu *code, QPopupMenu *sub, int c, bool b);
extern int popCodecMenu(QWidget *wdg, QPopupMenu *codecMenu, QPopupMenu *popCodec, int prgcode, int c);

extern const QPixmap *freqIco[freqIcons];

extern void sortAcc(QWidget *pwdg, int cnt);

extern void setCurCodeVal();

extern const QString tranText(QTextCodec *code, const char *txt);

extern void statusBarMsg(StatusPanel *sbar, const char *fmt, const char *pt, int color, int posStat=1);

extern void showLink(StatusPanel *sbar, const char *fmt, const char *pt, unsigned int C);

extern const char archNam[],
	sigactIdx[], sigact[], slot_sort[],
	*pcwd, *home;

// extern int *__params;

extern __ORD *ORLRoot, *descript, *FileAssoc, *iconDir, *selfDir;

extern int uId, gId, *usrIDs, *groupIDs;
extern FastBlock *usrList, *grpList;

extern FastBlock logNam;
extern char *logorName(int uid, int *ids, FastBlock *lst);

extern int wx, wy;
extern bool SetWdgPos(QWidget *wdg, __ORD *dir, int nmb, int wsz);
#define  setWdgFrame(wdg, dir, numb)  SetWdgPos(wdg, dir, numb, 0)
#define  setWdgSize(wdg, dir, numb)  SetWdgPos(wdg, dir, numb, 1)

extern void SaveWdgPos(QWidget *wdg, __ORD *dir, int nmb, int wsz);
#define  saveWdgSize(wdg, dir, nmb)  SaveWdgPos(wdg, dir, nmb,1)
#define  saveWdgFrame(wdg, dir, nmb)  SaveWdgPos(wdg, dir, nmb,0)

extern void SavFont(const QFont &fnt, int numb);
extern bool ReadFont(QFont & fnt, int numb);
extern void setListColWidth(QListView *vList, int num);
extern void saveListColWidth(QListView *vList, int num);
extern void appPost(int T, void *dat, QObject *obj);

extern QPixmap pix_Icon;
extern QPixmap *pixmapLoad(int numb);

extern void setListOption(ListOptions *opt, struct stat64 &st, bool b, int cnt);

extern const char **charsFromORL(int id);

extern FastBlock opens;
extern bool creatOpenMenu(QPopupMenu &menu, QWidget *obj, const char *fn);

extern QAction *addTA(QWidget *wdg, QToolBar *tools,	int Img,
	const char *tips, const char *menuText, const char *slot, int key, bool togg, bool on);

extern void scaleImage(QImage &img, int lmt);

extern int setItemImage(const char *pth, int lmt, QImage *brw, FastBlock *imgftmp);
extern void FileStat(ListOptions *sb, const char *useColumns, LVItem *it, const char *dtfmt, int off=1);

/* msg: 0 copy; 2 is ListOpera(chattr)
 -2 sm-add; -1 change(or listSet); -3 sm-notify(timer), -4 sm-sort, -5 add sm-listopera */
enum SetListItem { View_Add=0,  Opts_Chang=2,
	SM_Add=-2, ListSet_Chang=-1, SM_Notify=-3, SM_Sort=-4, LO_SM_Add=-5};
extern void *vInsertItem(QScrollView *vw, const char *fnam, int msg, int sz,
	const char *cols, const char *dtfmt, void *code, void *pos=NULL);

extern int fcanDrop(QDropEvent *e,  FastBlock *chs);

extern void procDrop(QWidget *wdg, Filesan *fs, QDropEvent *e, const char *dst);

extern void idCpFile(FastBlock &lst, const char *);

extern int _delFile(QWidget *, const char *pt);

extern int __operaDir(QWidget *wdg, int Msg, const char *dirnam, const char *filters, const struct fAttribRslt *fattr);

extern void listSetInit(QWidget *obj, ListContent **optList, const QRect &r, QPushButton **up, QPushButton **down, const char *colsInfo);

extern void moveListSet(ListContent *optList, char *colsInfo, int btn);

extern void getListOpts(ListContent *vlist, char *pval);

#define  deleteDir(wdg,fname, filters, _errno, loops)  operaDir(wdg, TEST_REMOVE_DIR, fname, filters, NULL, _errno, loops)

#endif
