/*
  Designed by Linjianghua(Xempo) 2004-2006, 2012,2014
  Free under LGPL
*/

#include "fculoop.h"
#include "dirext.h"
#include "infor.h"

static int del_mode, kRescue, kRedir;

__ORD *dst_dir;

static __ORD *usedORD(__ORL *lib, dskadr_t adr)
{
int i;
__ORD *dir;
for(i=0; i<lib->cnt_usedir; i++){
 dir=lib->usedirs[i];
 if(isNormDir(dir)){
     __ORD dirbuf;
     _loop_: if(dir->own_adr==adr)return dir;
     if(dir->parent_adr==0)continue;
     dir=ORDread(lib,&dirbuf,NULL,dir->parent_adr, False);
     goto _loop_;
   }
}
return NULL;
}

inline void Erase(__ORD *dir,BYTE *unit)
{
int i;
MAU send;
for(i=0;i<dir->DAUC;i++){
	send.len=*(int *)( pFcuDauPos(dir,unit,i) + sizeof(dskadr_t) );
	send.buf=(char *)zalloc(send.len);
	writeDAU(dir, unit, &send, i);
	free(send.buf);
	}
*unit|=3; /* wait for SS */
}

static int undelNum(__ORD *dir, BYTE *unit, dskadr_t pos)
{
      if(isZero(dir->Format)==False){
      	int nmb=FCU_Numb(dir,unit);
	BYTE *fcu;
      	if((fcu=seekFCU(dir,nmb,NULL,NUMB_BROW))!=NULL){
	char buf[102], *dscpt;
	switch(kRescue){
	case 'i' : break;
	case 'a' :  goto _skp_;
	default :	
		dscpt=GetHB(UndelNCover_26);
		free(fcu);	   sprintf(buf,dscpt,dir->name,nmb);
		free(dscpt);	   kRescue=popMsg(buf,NULL, 0, orlX);
		switch(kRescue){
		case 'n' : return 2;
		case Esc : return 0;
	   	}
		_skp_:	setDelTag(*fcu);
		DFCUmdf(dir, fcu, dir->lib->FCU_dyw, -1);
	}
	}
     }
      *unit=1|(*unit&(255-2));
      DFCUmdf(dir,unit,pos,1);
      return 1;
}

static int undelPd(__ORD *dir, DirFCU *du1)
{
      int pos=dir->lib->FCU_dyw;
      DirFCU *du;
      int rt=1;
      if((du=ORDseek(dir,du1->name,DIR_BROW))!=NULL){
	char buf[120], *dscpt;
	switch(kRedir){
	case 'i' : break;
	case 'a' :  goto _skp_;
	default :	dscpt=GetHB(UndelDCover_27);
		free(du);	sprintf(buf,dscpt,du1->name);
		free(dscpt);	kRedir=popMsg(buf,NULL,1, NULL);
		switch(kRedir){
		case  'n' : return 2;
		case Esc : return 0;
		}
		_skp_ : rt=ORDdel(dir,du1->name,0);
	}
	}
    dir->lib->FCU_dyw=pos;
    return rt;
}

static int numbFCU(__ORD *dir,BYTE *unit)
{
    int n, i, cntdir=dir->Num_FCUs_Block, unitlen=dir->Num_FCU_Len;/* protect bit flow */
    for(i=0; i<cntdir; i++,unit+=unitlen){
      if(_step<0){/* del */
	if((*unit&3)==1){
		int numb;
		char buf[200];
		if( unit[1]&ORL_OEM ){
			n=OEM_20;
			goto _wrong_;
		}
		if( (unit[1]&ORL_MW)==0){
			n=NoWrite_15;
		_wrong_:	numb=isZero(dir->Format) ? dir->NumbForZero+i : *(int *)(unit+FCU_NumPos);
			if(dir!=dst_dir){
			  char *pt=ORDpath(dir, dst_dir, 1);
			  sprintf(buf, " %s/%d", pt, numb );
			  free(pt);
			  }
			else sprintf(buf, " %d", numb );
			msgShow(buf);
			idxdscpt=n;
			return 0;
		}
		if(del_mode==ORL_erase)Erase(dir,unit);
		else setDelTag(*unit);
		DFCUmdf(dir,unit,dir->pos_numb_FCT+i*unitlen,-1);
	}
      }
      else if((*unit&3)==2)undelNum(dir, unit, dir->pos_numb_FCT+i*unitlen);
    }
    if(isZero(dir->Format))dir->NumbForZero+=cntdir;
    return 1;
}

static int pdFCU(__ORD *pcdir,__ORD *Dir)
{
  if(pcdir->mode&ORL_OEM){
    idxdscpt=OEM_20;
    goto _err_info_;
  }
  if((pcdir->mode&ORL_MW)==0){
    idxdscpt=NoWrite_15;
    _err_info_: reportBug();
    return 2;
  }

 if(_step>0){ /* dir Rescue */
      if(Dir->tag>1){
	int rt=undelPd(pcdir, (DirFCU *)(&Dir->tag) );
	if(rt!=1)return rt;
	setDFCU(pcdir, Dir, Dir->Own_FCU_Addr, Dir->selfsize);
		}
	}
 else if(Dir->tag==1){
	if(Dir->mode&ORL_OEM){
	    idxdscpt=OEM_20;
	    goto _err_proc_;
	}
	if((Dir->mode&ORL_MW)==0){
	    idxdscpt=NoWrite_15;
	    _err_proc_: reportBug();
	    return 2;
	}
/*	setDFCU(pcdir, Dir, Dir->Own_FCU_Addr, Dir->selfsize);*/
    return msg_Dir_Del;
  }
 return 1;
}

int FCU_ORDmdf(__ORD *pdir,DirFCU *du, int nCom)
{
  __ORL *lib=pdir->lib;
  unsigned int dirsz;
  dskadr_t pos=lib->FCU_dyw;
  __ORD *dir2, dirbuf;
  int rt, msg=LoopNum|LoopDir|LoopDirSub;
  ORDinit(&dirbuf);
  dir2=ORDread(lib, &dirbuf,du,du->pDir, True);
  del_mode=nCom;
  switch(nCom){
  case ORL_ndels  : msg=LoopNum|LoopDirSub;
	break;
  case DIR_RESCUE : msg=LoopNum|LoopDir|LoopDirSub|LoopForce;
  }
  dirsz=dir2->selfsize;
  dst_dir=dir2;
  kRedir=0; kRescue=0;
  rt=ORDbrowth(dir2, msg, numbFCU, pdFCU);
  if((rt&33) /* rt==1 || rt==32 */
/*	&&isNormDir(dir2)*/ ){
	if(nCom!=ORL_empty /* DirEmpty */ && nCom!=ORL_ndels)setDFCU(pdir, dir2, pos, nCom!=DIR_RESCUE? dir2->selfsize : dirsz);
	}
  ORDclose(dir2,2);
  return rt;
}

BOOL ORDdel(__ORD *dir,char *dirnam,int nCom)
{
 BOOL rt=False;
 DirFCU *du=ORDseek(dir,dirnam,DIR_DEL);
 if(idxdscpt>0x7ffd){
   if(nCom!=ORL_empty&&nCom!=ORL_ndels&&usedORD(dir->lib,du->pDir))idxdscpt=UsingDir_19;
   else {
	_step=-1;
	rt=FCU_ORDmdf(dir, du, nCom);
	}
   free(du);
 }
 if(rt==False)reportBug();/* 因有子目录，所以要实时报错，不同numb */
 return rt;
}

int ORDren(__ORD *dir,char *src, const char *dst)
{
  DirFCU *unit;
  if(nameCRC(dst)==False)idxdscpt=InvName_13;
    else if((unit=ORDseek(dir,dst,DIR_FCU_POS))!=NULL){ idxdscpt=DirExist_9; free(unit); }
        else if((unit=ORDseek(dir,src,DIR_REN))!=NULL){
		__ORL *lib=dir->lib;
		__ORD *dir1;
		if( (dir1=usedORD(lib, unit->pDir)) )namecpy(dir1->name,dst);
		dkwrite(lib,lib->FCU_dyw+FCU_NumPos/*  name_pos*/,dst,DirNamLen);
		free(unit);
		return 1;
           }
  if(idxdscpt<0x7ffd)ORtips(idxdscpt, getMsg ? 0:1);
  return 0;
}

