/*
	Write by xempo 12-2014
	Free under LGPL
*/

#include <dirent.h>
#include "ordir.h"
#include "stdfun.h"
#include "msgid.def"
#include "init.h"
#include "write.h"
#include "version.h"
#include "shellcom.h"
#include "conspace.h"
#include "infor.h"
#include "read.h"
#include "dlist.h"
#include "normal.h"

const char *rtfn, *pInfo="\nUnknown format : %s\n",
	filekey[]="--lang", dfltkey[]="en";

extern const char *paraSepa; // options.h

/* StrList orlPaths; */

int conVal;

const char *orfn(const char *fnam, const char *self, const char *inst, int *msg, const char **cwd)
{
const char *fn=fnam;
const char *pth=catstr(getenv(homestr), self, '/');
if(access(pth, F_OK))mkdir(pth, 0755);
fn = catstr(pth, fn, ROOT_CH );
if(*msg==0)free((void *)pth);
else *cwd=pth;
*msg=ini_norm;
if( access(fn, F_OK) ){
	char *instprg, *buf;
	unsigned int len;
	instprg=catstr( inst, fnam, '/');
	buf=ReadFile(instprg, &len, 0, orlX, &orlPaths);
	free(instprg);
	if(buf){
		FILE *fw;
		fw=fopen64(fn, "wb");
		if(fw){
			fwrite(buf, len, 1, fw);
			fclose(fw);
			*msg=ini_first;
		}
		else {
			pInfo="No right to create %s\n";
			*msg=ini_nowritable;
		}
		free(buf);
	}
	else {
		pInfo="No %s,\nInstall badly\n";
		*msg=ini_notinst;
	}
}
return fn;
}

int init(int *argc, char **argv, const char *conStr)
{
int i, rt;
char *tag, ext[32];
const char *fn, *fn0;
InpBuf=(char *)malloc(3*1024);	OutBuf=InpBuf+1024;
_argv=argv;	paraSepa=newSepa;
_env_path(*argv,NULL, &orlPaths);/* for read OpenRose, must done once here */
for(i=1; i<*argc; i++)
	if((conVal=GetComm(argv[i], conStr, NULL, NULL))!=NotCommand){
		if(conVal)_rm_pm_:	for((*argc)--; i<*argc; i++)argv[i]=argv[i+1];
		else { // ==0, --lang
			if(*argc>i+1){
				fn0=catstr(rtfile, argv[i+1], '.');
				for((*argc)-=2; i<*argc; i++)argv[i]=argv[i+2];
				goto _skp_;
			}
			else {
				puts("Lost extern name for --lang");
				goto _rm_pm_;
				}
			}
		}
char *pt=getenv("LANG");
if(pt){
	int j;
	char *ptr=strchr(pt, '.');
	if(ptr)i=ptr-pt;
	else i=strlen(pt);
	for(j=0; j<i; j++)ext[j]=pt[j];
	ext[i]=0;
}
_re_cat_: fn0=catstr(rtfile, pt? ext : dfltkey, '.');
_skp_: tag=strstr(fn0, dfltkey);
rt=0;
fn=orfn(fn0, orlSelf, instpth, &rt, NULL);
free((void *)fn0);
rtfn=fn;
if(rt>ini_first){
	if(tag)return rt;
	pt=NULL;
	goto _re_cat_;
}
__ORL *lib=ORLuse(fn, OpenAlway|HasFullPath|FastBuf);
if(lib){
  char *pth;
  ORputas(lib, 0);
  comchs=(const char *)GetHB(I_CmdChr);
  if(comchs==NULL){
	pInfo="\nFail to get COMMAND in %s\n";
	return ini_nocom;
	}
  kval=(const _Int *)GetHB(I_CmdNum);
  if((pth=sysIdRead(lib, 2))!=NULL){ /* read self-path */
	free(orlPaths.argv[0]);	free(orlPaths.argv);
	_env_path(*argv, pth, &orlPaths);
	free(pth);
	}
i=7;
rt_msg=(const char **)setargv(GetHB(37), "^", &i);
return rt ? ini_first : ini_norm;
}
return ini_notorl;
}
