/*
  Write & edit by Linjianghua 2004-2006, 2014
  Free under LGPL
*/

#ifndef  ORL_IO
#define  ORL_IO

#include "envpath.h"

typedef enum { RScript=1, CompactMsg=2, ORLerror=4, OpenLastDir=8,
	ScriptError=16, ORLopeninfo=32, OpenAlway=64, HasFullPath=256,
	FastBuf=512,  DectName=1024
	}OpenSpace;

extern const char extORL[];
extern const BYTE FileFmt[blockSize];
extern StrList orlPaths;

extern __ORL *ORLalloc();

__BEGIN_DECLS
/* msg是一个位合成值，含2个意义：DectName(512)和FastBuf(1024)，一般在稳定运行中使用DectName|FastBuf。 */
extern __ORL *ORLopen(const char *fname, int msg/* show fail-msg, such Fophonix...*/);

extern void ORLclose(__ORL *,__ORL* (*Compr)(__ORL *,const char *, int msg));
__END_DECLS

#endif
